'use strict';

var debug = require('debug')('request');
var req = require('request').defaults({ jar: true });
var Task = require('data.task');

module.exports = function (opts) {
  return new Task(function (rej, res) {
    debug('sending request: %o', opts);
    req(opts, function (err, response, body) {
      if (err) {
        rej(err);
      } else if (response.statusCode !== 200) {
        rej('Request failed, Status ' + response.statusCode);
      } else {
        res(body);
      }
    });
  });
};